<!-- 询价消息-卖方询价-同意/拒绝 -->
<template>
    <app-drawer title="提示" :width="480" v-model:show="show" :loading="loading" :refresh="refresh">
        <el-form ref="formRef" label-width="60px" :model="formData" :rules="formRules">
            <el-form-item>
                <span>是否{{ code === 'bargain_sell_agree' ? '同意' : '拒绝' }}此询价？</span>
            </el-form-item>
            <el-form-item label="备注" prop="AuditRemark">
                <el-input type="textarea" :rows="3" v-model="formData.AuditRemark" />
            </el-form-item>
        </el-form>
        <template #footer>
            <el-button @click="onCancel(false)" plain>取消</el-button>
            <el-button type="primary" @click="onSubmit">确认</el-button>
        </template>
    </app-drawer>
</template>

<script lang="ts" setup>
import { ref, PropType } from 'vue'
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { useBargainOperate } from '@/business/bargain'
import AppDrawer from '@pc/components/base/drawer/index.vue'

const props = defineProps({
    code: String,
    selectedRow: {
        type: Object as PropType<Ermcp.MyDelistingApplyRsp>,
        default: () => ({})
    },
})

const operateType = (() => {
    switch (props.code) {
        case 'bargain_sell_agree': {
            return 3
        }
        case 'bargain_sell_refuse': {
            return 2
        }
    }
    return 0
})()

const { loading, formData, formSubmit } = useBargainOperate(props.selectedRow)
const show = ref(true)
const refresh = ref(false)
const formRef = ref<FormInstance>()

const formRules: FormRules = {
    AuditRemark: [{ required: true, message: '请输入备注', trigger: 'blur' }],
}

const onCancel = (isRefresh = false) => {
    show.value = false
    refresh.value = isRefresh
}

const onSubmit = () => {
    formRef.value?.validate((valid) => {
        if (valid) {
            formSubmit(operateType).then(() => {
                ElMessage.success('提交成功')
                onCancel(true)
            }).catch((err) => {
                ElMessage.error('提交失败：' + err)
            })
        }
    })
}
</script>